<?php


Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Provider".
 *
 * Columns in table "provider" available as properties of the model,
 * followed by relations of table "provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $country_id
 * @property integer $localization_id
 * @property string $first_last
 * @property string $first_m_last
 * @property string $first_middle_last
 * @property string $npi_id
 * @property string $gender
 * @property integer $credential_id
 * @property string $prefix
 * @property string $first_name
 * @property string $middle_name
 * @property string $last_name
 * @property string $vanity_specialty
 * @property string $suffix
 * @property integer $docscore
 * @property integer $accepts_new_patients
 * @property string $year_began_practicing
 * @property string $additional_specialty_information
 * @property string $brief_bio
 * @property string $bio
 * @property string $fees
 * @property integer $avg_rating
 * @property integer $is_test
 * @property string $friendly_url
 * @property string $photo_path
 * @property string $date_added
 * @property string $date_updated
 * @property string $umd_id
 * @property string $date_umd_updated
 * @property integer $featured
 * @property integer $claimed
 * @property integer $suspended
 * @property string $display_search_order
 *
 * @property AccountDetails[] $accountDetails
 * @property AccountDeviceProvider[] $accountDeviceProviders
 * @property AccountProvider[] $accountProviders
 * @property ClientProvider[] $clientProviders
 * @property OrganizationFeature[] $organizationFeatures
 * @property OrganizationHistory[] $organizationHistories
 * @property PartnerSiteProviderFeatured[] $partnerSiteProviderFeatureds
 * @property PracticeDetails[] $practiceDetails
 * @property Credential $credential
 * @property ProviderAward[] $providerAwards
 * @property ProviderCertification[] $providerCertifications
 * @property ProviderDetails[] $providerDetails
 * @property ProviderEducation[] $providerEducations
 * @property ProviderExperience[] $providerExperiences
 * @property ProviderForm[] $providerForms
 * @property ProviderHospital[] $providerHospitals
 * @property ProviderLanguage[] $providerLanguages
 * @property ProviderMembership[] $providerMemberships
 * @property ProviderPaymentType[] $providerPaymentTypes
 * @property ProviderPhoto[] $providerPhotos
 * @property ProviderPopulation[] $providerPopulations
 * @property ProviderPractice[] $providerPractices
 * @property ProviderPracticeInsurance[] $providerPracticeInsurances
 * @property ProviderPracticeListing[] $providerPracticeListings
 * @property ProviderPracticeWidget[] $providerPracticeWidgets
 * @property ProviderPublication[] $providerPublications
 * @property ProviderRating[] $providerRatings
 * @property ProviderResidency[] $providerResidencies
 * @property ProviderSchedule[] $providerSchedules
 * @property ProviderSpecialty[] $providerSpecialties
 * @property ProviderStats[] $providerStats
 * @property ProviderStatsReport[] $providerStatsReports
 * @property ProviderSuspended[] $providerSuspendeds
 * @property ProviderTreatment[] $providerTreatments
 * @property ProviderTreatmentPerformed[] $providerTreatmentPerformeds
 * @property ProviderUrlHistory[] $providerUrlHistories
 * @property ProviderVideo[] $providerVideos
 * @property QualityPath[] $qualityPaths
 * @property SchedulingMail[] $schedulingMails
 */
abstract class BaseProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Provider|Providers', $n);
    }

    public static function representingColumn()
    {
        return 'first_m_last';
    }

    public function rules()
    {
        return array(
            array(
                'first_name, last_name, first_m_last, first_middle_last, credential_id, friendly_url,
                    display_search_order',
                'required'
            ),
            array(
                'country_id, localization_id, credential_id, docscore, accepts_new_patients, avg_rating, is_test,
                    featured, claimed, suspended',
                'numerical',
                'integerOnly' => true
            ),
            array('first_last', 'length', 'max' => 131),
            array('first_m_last', 'length', 'max' => 133),
            array('first_middle_last', 'length', 'max' => 182),
            array('vanity_specialty', 'length', 'max' => 100),
            array('npi_id', 'length', 'max' => 10),
            array('gender', 'length', 'max' => 1),
            array('prefix', 'length', 'max' => 3),
            array('first_name, middle_name', 'length', 'max' => 50),
            array('umd_id', 'length', 'max' => 20),
            array('last_name', 'length', 'max' => 80),
            array('suffix', 'length', 'max' => 5),
            array('year_began_practicing', 'length', 'max' => 4),
            array('additional_specialty_information, friendly_url, photo_path', 'length', 'max' => 255),
            array('brief_bio', 'length', 'max' => 170),
            array('display_search_order', 'length', 'max' => 9),
            array('bio, fees, date_added, date_updated, date_umd_updated', 'safe'),
            array(
                'country_id, localization_id, first_last, npi_id, gender, prefix, middle_name, suffix, docscore,
                    accepts_new_patients, year_began_practicing, additional_specialty_information, brief_bio, bio,
                    fees, avg_rating, photo_path, date_added, date_updated, umd_id, date_umd_updated, featured,
                    claimed, suspended, display_search_order',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, country_id, localization_id, first_last, first_m_last, first_middle_last, npi_id, gender,
                    credential_id, prefix, first_name, middle_name, last_name, suffix, docscore, accepts_new_patients,
                    year_began_practicing, additional_specialty_information, brief_bio, bio, fees, avg_rating,
                    is_test, friendly_url, photo_path, date_added, date_updated, umd_id, date_umd_updated, featured,
                    claimed, suspended, vanity_specialty, display_search_order',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'accountDetails' => array(self::HAS_MANY, 'AccountDetails', 'claimed_provider_id'),
            'accountDeviceProviders' => array(self::HAS_MANY, 'AccountDeviceProvider', 'provider_id'),
            'accountProviders' => array(self::HAS_MANY, 'AccountProvider', 'provider_id'),
            'clientProviders' => array(self::HAS_MANY, 'ClientProvider', 'provider_id'),
            'organizationFeatures' => array(self::HAS_MANY, 'OrganizationFeature', 'provider_id'),
            'organizationHistories' => array(self::HAS_MANY, 'OrganizationHistory', 'provider_id'),
            'partnerSiteProviderFeatureds' => array(self::HAS_MANY, 'PartnerSiteProviderFeatured', 'provider_id'),
            'practiceDetails' => array(self::HAS_MANY, 'PracticeDetails', 'sole_proprietor_provider_id'),
            'credential' => array(self::BELONGS_TO, 'Credential', 'credential_id'),
            'providerAwards' => array(self::HAS_MANY, 'ProviderAward', 'provider_id'),
            'providerCertifications' => array(self::HAS_MANY, 'ProviderCertification', 'provider_id'),
            'providerDetails' => array(self::HAS_MANY, 'ProviderDetails', 'provider_id'),
            'providerEducations' => array(self::HAS_MANY, 'ProviderEducation', 'provider_id'),
            'providerExperiences' => array(self::HAS_MANY, 'ProviderExperience', 'provider_id'),
            'providerForms' => array(self::HAS_MANY, 'ProviderForm', 'provider_id'),
            'providerHospitals' => array(self::HAS_MANY, 'ProviderHospital', 'provider_id'),
            'providerLanguages' => array(self::HAS_MANY, 'ProviderLanguage', 'provider_id'),
            'providerMemberships' => array(self::HAS_MANY, 'ProviderMembership', 'provider_id'),
            'providerPaymentTypes' => array(self::HAS_MANY, 'ProviderPaymentType', 'provider_id'),
            'providerPhotos' => array(self::HAS_MANY, 'ProviderPhoto', 'provider_id'),
            'providerPopulations' => array(self::HAS_MANY, 'ProviderPopulation', 'provider_id'),
            'providerPractices' => array(self::HAS_MANY, 'ProviderPractice', 'provider_id'),
            'providerPracticeInsurances' => array(self::HAS_MANY, 'ProviderPracticeInsurance', 'provider_id'),
            'providerPracticeListings' => array(self::HAS_MANY, 'ProviderPracticeListing', 'provider_id'),
            'providerPracticeWidgets' => array(self::HAS_MANY, 'ProviderPracticeWidget', 'provider_id'),
            'providerPublications' => array(self::HAS_MANY, 'ProviderPublication', 'provider_id'),
            'providerRatings' => array(self::HAS_MANY, 'ProviderRating', 'provider_id'),
            'providerResidencies' => array(self::HAS_MANY, 'ProviderResidency', 'provider_id'),
            'providerSchedules' => array(self::HAS_MANY, 'ProviderSchedule', 'provider_id'),
            'providerSpecialties' => array(self::HAS_MANY, 'ProviderSpecialty', 'provider_id'),
            'providerStats' => array(self::HAS_MANY, 'ProviderStats', 'provider_id'),
            'providerStatsReports' => array(self::HAS_MANY, 'ProviderStatsReport', 'provider_id'),
            'providerSuspendeds' => array(self::HAS_MANY, 'ProviderSuspended', 'provider_id'),
            'providerTreatments' => array(self::HAS_MANY, 'ProviderTreatment', 'provider_id'),
            'providerTreatmentPerformeds' => array(self::HAS_MANY, 'ProviderTreatmentPerformed', 'provider_id'),
            'providerUrlHistories' => array(self::HAS_MANY, 'ProviderUrlHistory', 'provider_id'),
            'providerVideos' => array(self::HAS_MANY, 'ProviderVideo', 'provider_id'),
            'qualityPaths' => array(self::HAS_MANY, 'QualityPath', 'provider_id'),
            'schedulingMails' => array(self::HAS_MANY, 'SchedulingMail', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'country_id' => Yii::t('app', 'Country'),
            'localization_id' => Yii::t('app', 'Localization'),
            'first_last' => Yii::t('app', 'First Last'),
            'first_m_last' => Yii::t('app', 'First M Last'),
            'first_middle_last' => Yii::t('app', 'First Middle Last'),
            'npi_id' => Yii::t('app', 'Npi'),
            'gender' => Yii::t('app', 'Gender'),
            'credential_id' => null,
            'prefix' => Yii::t('app', 'Prefix'),
            'first_name' => Yii::t('app', 'First Name'),
            'middle_name' => Yii::t('app', 'Middle Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'vanity_specialty' => Yii::t('app', 'Vanity Specialty'),
            'suffix' => Yii::t('app', 'Suffix'),
            'docscore' => Yii::t('app', 'Docscore'),
            'accepts_new_patients' => Yii::t('app', 'Accepts New Patients'),
            'year_began_practicing' => Yii::t('app', 'Year Began Practicing'),
            'additional_specialty_information' => Yii::t('app', 'Additional Specialty Information'),
            'brief_bio' => Yii::t('app', 'Brief Bio'),
            'bio' => Yii::t('app', 'Bio'),
            'fees' => Yii::t('app', 'Fees'),
            'avg_rating' => Yii::t('app', 'Avg Rating'),
            'is_test' => Yii::t('app', 'Is Test'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'photo_path' => Yii::t('app', 'Photo Path'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'umd_id' => Yii::t('app', 'Umd'),
            'date_umd_updated' => Yii::t('app', 'Date Umd Updated'),
            'featured' => Yii::t('app', 'Featured'),
            'claimed' => Yii::t('app', 'Claimed'),
            'suspended' => Yii::t('app', 'Suspended'),
            'accountDetails' => null,
            'accountDeviceProviders' => null,
            'accountProviders' => null,
            'clientProviders' => null,
            'organizationFeatures' => null,
            'organizationHistories' => null,
            'partnerSiteProviderFeatureds' => null,
            'practiceDetails' => null,
            'credential' => null,
            'providerAwards' => null,
            'providerCertifications' => null,
            'providerDetails' => null,
            'providerEducations' => null,
            'providerExperiences' => null,
            'providerForms' => null,
            'providerHospitals' => null,
            'providerLanguages' => null,
            'providerMemberships' => null,
            'providerPaymentTypes' => null,
            'providerPhotos' => null,
            'providerPopulations' => null,
            'providerPractices' => null,
            'providerPracticeInsurances' => null,
            'providerPracticeListings' => null,
            'providerPracticeWidgets' => null,
            'providerPublications' => null,
            'providerRatings' => null,
            'providerResidencies' => null,
            'providerSchedules' => null,
            'providerSpecialties' => null,
            'providerStats' => null,
            'providerStatsReports' => null,
            'providerSuspendeds' => null,
            'providerTreatments' => null,
            'providerTreatmentPerformeds' => null,
            'providerUrlHistories' => null,
            'providerVideos' => null,
            'qualityPaths' => null,
            'schedulingMails' => null,
            'display_search_order' => Yii::t('app', 'Display Search Order'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('country_id', $this->country_id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('first_last', $this->first_last, true);
        $criteria->compare('first_m_last', $this->first_m_last, true);
        $criteria->compare('first_middle_last', $this->first_middle_last, true);
        $criteria->compare('npi_id', $this->npi_id, true);
        $criteria->compare('gender', $this->gender, true);
        $criteria->compare('credential_id', $this->credential_id);
        $criteria->compare('vanity_specialty', $this->vanity_specialty);
        $criteria->compare('prefix', $this->prefix, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('middle_name', $this->middle_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('suffix', $this->suffix, true);
        $criteria->compare('docscore', $this->docscore);
        $criteria->compare('accepts_new_patients', $this->accepts_new_patients);
        $criteria->compare('year_began_practicing', $this->year_began_practicing, true);
        $criteria->compare('additional_specialty_information', $this->additional_specialty_information, true);
        $criteria->compare('brief_bio', $this->brief_bio, true);
        $criteria->compare('bio', $this->bio, true);
        $criteria->compare('fees', $this->fees, true);
        $criteria->compare('avg_rating', $this->avg_rating);
        $criteria->compare('is_test', $this->is_test);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('photo_path', $this->photo_path, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('umd_id', $this->umd_id, true);
        $criteria->compare('date_umd_updated', $this->date_umd_updated, true);
        $criteria->compare('featured', $this->featured);
        $criteria->compare('claimed', $this->claimed);
        $criteria->compare('suspended', $this->suspended);
        $criteria->compare('display_search_order', $this->display_search_order, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
}
